clear all
%% Parametre
bildenummer = 335;
r_min = 20;
r_max = 200;
temp_min = 50;
temp_max = 1000;

%% Load range
range_RGB = imread('C:\Documents and Settings\Jon Petter\My Documents\Skole\Diplomoppgave Vr 2008\Heatbalance\ranges\r20-200_2.bmp');
r_length = size(range_RGB,1);

%% Load image
% SU4 A004 Bunn
Image = imread(['..\heatbalance\SU4\A 004\Bunn\Bunn\IR20080430_0',num2str(bildenummer),'.bmp']);
Image_original = Image;

% SU4 A004 Topp - kortside midtgang
% Image = imread(['..\heatbalance\SU4\A 004\Topp\Kortside midtgang\IR20080430_0',num2str(bildenummer),'.bmp']);

% SU4 A059 Bunn - kortside midtgang IR20080429_00132
% Image = imread(['..\heatbalance\SU4\A 059\Bunn\Kortside midtgang\IR20080429_00',num2str(bildenummer),'.bmp']);

width = size(Image,2);    %Bildebredde
height = size(Image,1);   %Bildehyde

%% Temperature vector
T = linspace(r_min,r_max,r_length)';    %Linert temperaturspekter fra min.- til maks-temperatur

%% Connectivity matrix
% Kobler fargenummer med temperatur. Siden antall farger i spekteret
% reduseres av Matlab nr bildene indekseres, vil i utgangspunktet de
% fleste farger representere mer enn n temperatur. Hver farge blir da satt
% til  representere gjennomsnittet av disse temperaturene.
conmat = zeros(r_length,4);
conmat(:,1) = T;
for i = 1:r_length
    for j = 2:4
        conmat(i,j) = double(range_RGB(i,1,j-1));
    end
end

%% Average temperatur, temp.range
% Gr gjennom fargespekteret. For hver farge som finnes summeres den
% respektive temperaturen opp, og deles til slutt p antall temperaturer
% som er summert opp.
T_avg = 0;
for i = 1:r_length
    R = range_RGB(i,1,1); G = range_RGB(i,1,2); B = range_RGB(i,1,3);
    fargeindeks = find((conmat(:,2)==R & conmat(:,3)==G & conmat(:,4)==B));
    temp = conmat(fargeindeks,1);
    T_avg = T_avg + temp;
end
T_avg = T_avg / r_length;
disp(['Kontrollsnitt: ',num2str(T_avg),'. (Skal vre ',num2str((r_max+r_min)/2),').']);
disp(' ')

%% Gjennomsnittstemperatur 2D-bilde
T_avg = 0;
teller = 0;
maxTemp = 0;
minTemp = 1000;
for i = 1:height
    for j = 1:width
        R = Image(i,j,1);
        fargeindeks = finn_fargeindeks(conmat,R,G,B); %Rd er den dominerende nyansen og fr bestemme fargevalg
        if (fargeindeks > 314) || (fargeindeks < 1)
            pause
        end
        temp = conmat(fargeindeks,1);
        %Hvis fargens temperatur tilsvarer temp_min eller lavere, eller
        %temp_max eller hyere, sett farge lik farge nummer 0 (nesten svart)
        if (temp <= temp_min)
            Image(i,j,:) = 0;
%         elseif (temp >= temp_max)
%             Image(i,j,:) = 0;
        else    %Beregner kun de feltene p bildet med temperaturer mellom temp_min og temp_max
            T_avg = T_avg + temp;
            teller = teller + 1;
            if temp >= maxTemp      %Finner maks.temp. og posisjon
                maxTemp = temp;
                maxTpos = [i,j];
            end
            if temp < minTemp       %Finner min.temp. og posisjon
                minTemp = temp;
                minTpos = [i,j];
            end
        end
    end
end
T_avg = T_avg/teller;   %Gjennomsnittstemperatur

%% Display
figure(1); imshow(Image_original);
figure(2); imshow(Image);

disp(['Snittstemperatur for bilde nummer ',num2str(bildenummer),' er ',num2str(T_avg),' grader celsius. Areal = ',num2str(teller),' piksler.'])
disp(['Minimumstemperatur er ',num2str(minTemp),' grader.'])
disp(['Makstemperatur er ',num2str(maxTemp),' grader.'])
disp(' ')