clear all
%% Parametre
bildenummer = 294;
bildeversjon = 82;
r_min = 20;     %Temperatur-skala
r_max = 350;
temp_min = 20;
temp_max = 350;

%% Load range
range_RGB = imread('C:\Documents and Settings\Jon Petter\My Documents\Skole\Diplomoppgave Vr 2008\Heatbalance\ranges\r20-200_2.bmp');
r_length = size(range_RGB,1);

%% Konstruerer eget fargekart og range
map2 = zeros(r_length,3);
for i = 1:r_length
    for j = 1:3
        map2(i,j) = double(range_RGB(i,1,j))/255;
    end
end

range2 = (0:1:313)';

%% Load image
% SU4 A004 
%%%%%%%%%%
% Bunn - Bunn
% Image = imread(['..\heatbalance\SU4\A 004\Bunn\Bunn\IR20080430_0',num2str(bildenummer),'.bmp']);

% Bunn - Langside minus
% Image = imread(['..\heatbalance\SU4\A 004\Bunn\Langside minus\gimped\IR20080430_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% Bunn - Langside pluss
% Image = imread(['..\heatbalance\SU4\A 004\Bunn\Langside pluss\gimped\IR20080429_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% Bunn - Kortside midtgang
% Image = imread(['..\heatbalance\SU4\A 004\Bunn\Kortside midtgang\gimped\IR20080429_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% Bunn - Kortside bakside
% Image = imread(['..\heatbalance\SU4\A 004\Bunn\Kortside yttervegg\gimped\IR20080429_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% Bunn - Hjrne - Midtgang minus
% Image = imread(['..\heatbalance\SU4\A 004\Bunn\Hjrne midtgang minus\gimped\IR20080429_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% Bunn - Hjrne - Midtgang pluss
% Image = imread(['..\heatbalance\SU4\A 004\Bunn\Hjrne midtgang pluss\gimped\IR20080429_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% Bunn - Hjrne - Yttervegg minus
% Image = imread(['..\heatbalance\SU4\A 004\Bunn\Hjrne yttervegg minus\gimped\IR20080429_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% Bunn - Hjrne - Yttervegg pluss
Image = imread(['..\heatbalance\SU4\A 004\Bunn\Hjrne yttervegg pluss\gimped\IR20080429_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% Topp - kortside midtgang
% Image = imread(['..\heatbalance\SU4\A 004\Topp\Kortside
% midtgang\gimped\IR20080430_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% Topp - kortside midtgang
% Image = imread(['..\heatbalance\SU4\A 004\Topp\Kortside yttervegg\gimped\IR20080430_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% % Topp - Langside minus
% Image = imread(['..\heatbalance\SU4\A 004\Topp\Langside minus\gimped\IR20080430_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% Topp - Langside minus
% Image = imread(['..\heatbalance\SU4\A 004\Topp\Langside pluss\gimped\IR20080430_0',num2str(bildenummer),'_',num2str(bildeversjon),'.bmp']);

% SU4 A059
%%%%%%%%%%
% Bunn - kortside midtgang IR20080429_00132
% Image = imread(['..\heatbalance\SU4\A 059\Bunn\Kortside midtgang\IR20080429_00',num2str(bildenummer),'.bmp']);

% Topp - Langside minus
% Image = imread(['..\heatbalance\SU4\A 059\Topp\Langside minus\IR20080429_0',num2str(bildenummer),'.bmp']);

% Topp - Kortende yttervegg
% Image = imread(['..\heatbalance\SU4\A 059\Topp\Kortende
% yttervegg\IR20080429_0',num2str(bildenummer),'.bmp']);

Image_I2 = rgb2ind(Image,map2,'nodither');  %Tilpasser bildet til samme fargekart brukt p temperaturspekteret.
Image_I_original = Image_I2;

im_width = size(Image_I2,2);    %Bildebredde
im_height = size(Image_I2,1);   %Bildehyde

%% Temperature vector
T = linspace(r_min,r_max,r_length)';    %Linert temperaturspekter fra min.- til maks-temperatur

%% Connectivity matrix
% Kobler fargenummer med temperatur. 
conmat2 = [double(range2),T];

%% Average temperatur, temp.range
% Gr gjennom fargespekteret. For hver farge som finnes summeres den
% respektive temperaturen opp, og deles til slutt p antall temperaturer
% som er summert opp.
T_avg2 = 0;
for i = 1:r_length
    fargeindeks2 = find(conmat2(:,1)==range2(i)); %Finner fargens plassering i conmat2
    temp2 = conmat2(fargeindeks2,2);           %Finner samsvarende temperatur
    T_avg2 = T_avg2 + temp2;
end
T_avg2 = T_avg2 / r_length;
disp(['Kontrollsnitt: ',num2str(T_avg2),'. (Skal vre ',num2str((r_max+r_min)/2),').']);
disp(' ')

%% Gjennomsnittstemperatur 2D-bilde
T_avg2 = 0;
teller2 = 0;
maxTemp2 = 0;
minTemp2 = 1000;

fordeling = zeros(1,im_width*im_height);
for i = 1:im_height
    for j = 1:im_width
        fargeindeks2 = find(conmat2(:,1)==Image_I2(i,j)); %Kobler farge med temperatur
        temp2 = conmat2(fargeindeks2,2);
        %Hvis fargens temperatur tilsvarer temp_min eller lavere, eller
        %temp_max eller hyere, sett farge lik farge nummer 0 (nesten svart)
        if (temp2 <= temp_min)
            Image_I2(i,j) = 0;
        elseif (temp2 >= temp_max)
            Image_I2(i,j) = 0;
        else    %Beregner kun de feltene p bildet med temperaturer mellom temp_min og temp_max
            T_avg2 = T_avg2 + temp2;
            teller2 = teller2 + 1;
            fordeling(teller2) = temp2;
            if temp2 > maxTemp2      %Finner maks.temp. og posisjon
                maxTemp2 = temp2;
                maxTpos2 = [i,j];
            end
            if temp2 < minTemp2       %Finner min.temp. og posisjon
                minTemp2 = temp2;
                minTpos2 = [i,j];
            end
        end
    end
end
% Image_I2(maxTpos2(1),maxTpos2(2)) = 200;
% Image_I2(minTpos2(1),minTpos2(2)) = 100;
T_avg2 = T_avg2/teller2;   %Gjennomsnittstemperatur

[arne,bjarne,fordeling] = find(fordeling); %Fjerner alle elementer = 0

[mu,sigma,muci,sigmaci] = normfit(fordeling);
skjevhet = skewness(fordeling);
flathet = kurtosis(fordeling);
x = (mu-4*sigma):0.1:(mu+4*sigma);
pdfNormal = normpdf(x,mu,sigma);

%% Resultater
figure(1); imshow(Image_I_original,map2);
figure(2); imshow(Image_I2,map2);

% figure(3); clf; plot(x,pdfNormal);
% hold all;  plot([mu,mu],[0,max(pdfNormal)]);
% xlabel('Temperatur, \circC');
% legend('Normalfordeling',['\mu (',num2str(mu),' \circC)'],2)
% figure(4); clf; histfit(fordeling,15);
% legend('histogram','normalfordeling')
% xlabel(['Skjevhet: ',num2str(skjevhet),'. Flathet: ',num2str(flathet)])

disp(['Bilde #',num2str(bildenummer),'_',num2str(bildeversjon),' gir flgende data:'])
% disp('Areal (piksler) =')
% disp([num2str(teller2)])
disp('Middelverdi   Ant.px.    Tmin     Tmax    Std.avvik   Skjevhet  Spisshet  95%konf.int.std    95%konf.int.mu')
tilexcel = [mu teller2 minTemp2 maxTemp2 sigma skjevhet flathet sigmaci' muci'];
disp(tilexcel)
num2clip(tilexcel);