clear all
%% Parametre
bildenummer = 1562;
r_min = 20;
r_max = 250;
temp_min = 50;
temp_max = 200;

%% Load range
range_RGB = imread('C:\Documents and Settings\Jon Petter\My Documents\Skole\Diplomoppgave Vr 2008\Heatbalance\ranges\r20-200_2.bmp');
[range_I,map] = rgb2ind(range_RGB);    %Gjr om til indeksert bilde, map er fargekartet
range_gray = rgb2gray(range_RGB);   %Gjr om til grtoner

map_length = size(map,1);
r_length = size(range_I,1);

%% Konstruerer eget fargekart
map2 = zeros(r_length,3);
for i = 1:r_length
    for j = 1:3
        map2(i,j) = double(range_RGB(i,1,j))/255;
    end
end

%% Konstruerer egen range
range2 = (0:1:313)';


%% Load image
% SU4 A004 Bunn
% Image = imread(['..\heatbalance\SU4\A 004\Bunn\Bunn\IR20080430_0',num2str(bildenummer),'.bmp']);

% SU4 A004 Topp - kortside midtgang
% Image = imread(['..\heatbalance\SU4\A 004\Topp\Kortside midtgang\IR20080430_0',num2str(bildenummer),'.bmp']);

% SU4 A059 Bunn - kortside midtgang IR20080429_00132
% Image = imread(['..\heatbalance\SU4\A 059\Bunn\Kortside midtgang\IR20080429_00',num2str(bildenummer),'.bmp']);

% SU4 A059 Topp - Langside minus
% Image = imread(['..\heatbalance\SU4\A 059\Topp\Langside minus\IR20080429_0',num2str(bildenummer),'.bmp']);

% SU4 A059 Topp - Kortende yttervegg
Image = imread(['..\heatbalance\SU4\A 059\Topp\Kortende yttervegg\IR20080429_0',num2str(bildenummer),'.bmp']);

Image_I = rgb2ind(Image,map,'dither');   %Tilpasser bildet til samme fargekart brukt p temperaturspekteret.
Image_I2 = rgb2ind(Image,map2,'nodither');
Image_I_original = Image_I;
Image_gray = rgb2gray(Image);   %Gjr om til grtoner
range_gray_length = 256;

im_width = size(Image_I,2);    %Bildebredde
im_height = size(Image_I,1);   %Bildehyde

%% Temperature vector
T = linspace(r_min,r_max,r_length)';    %Linert temperaturspekter fra min.- til maks-temperatur

%% Connectivity matrix
% Kobler fargenummer med temperatur. Siden antall farger i spekteret
% reduseres av Matlab nr bildene indekseres, vil i utgangspunktet de
% fleste farger representere mer enn n temperatur. Hver farge blir da satt
% til  representere gjennomsnittet av disse temperaturene.
conmat_init = [double(range_I),T];
conmat = zeros(map_length,1);   %Endelig conmat-matrise gir hver farge en unik tilsvarende temperatur
for i=0:map_length-1
    funn = find(conmat_init(:,1)==i);   %Finner temp. som representeres av hver enkelt farge
    T_avg = sum(T(funn)) / size(T(funn),1);   %Tar snittet av disse temperaturene
    conmat(i+1,1) = i;
    conmat(i+1,2) = T_avg;
end

%Gjr det samme for grtt
conmat_init_gray = [double(range_gray),T];
conmat_gray = zeros(range_gray_length,1);   %Endelig conmat-matrise gir hver farge en unik tilsvarende temperatur
for i=0:range_gray_length-1
    funn = find(conmat_init_gray(:,1)==i);   %Finner temp. som representeres av hver enkelt farge
    if funn
        T_avg = sum(T(funn)) / size(T(funn),1);   %Tar snittet av disse temperaturene
        conmat_gray(i+1,1) = i;
        conmat_gray(i+1,2) = T_avg;
    end
end
remove = find(conmat_gray(:,2)==0);
conmat_gray(remove,:) = [];

conmat2 = [double(range2),T];

%% Average temperatur, temp.range
% Gr gjennom fargespekteret. For hver farge som finnes summeres den
% respektive temperaturen opp, og deles til slutt p antall temperaturer
% som er summert opp.
T_avg = 0;
T_avg2 = 0;
T_avg_gray = 0;
for i = 1:r_length
    fargeindeks = find(conmat(:,1)==range_I(i)); %Finner fargens plassering i conmat
    fargeindeks2 = find(conmat2(:,1)==range2(i)); %Finner fargens plassering i conmat2
    fargeindeks3 = find(conmat_gray(:,1)==range_gray(i)); %Finner grtonens plassering i conmat_gray
    temp = conmat(fargeindeks,2);           %Finner samsvarende temperatur
    temp2 = conmat2(fargeindeks2,2);           %Finner samsvarende temperatur
    temp3 = conmat_gray(fargeindeks3,2);
    T_avg = T_avg + temp;
    T_avg2 = T_avg2 + temp2;
    T_avg_gray = T_avg_gray + temp3;
end
T_avg = T_avg / r_length;
disp(['Kontrollsnitt: ',num2str(T_avg),'. (Skal vre ',num2str((r_max+r_min)/2),').']);
T_avg2 = T_avg2 / r_length;
disp(['Kontrollsnitt: ',num2str(T_avg2),'. (Skal vre ',num2str((r_max+r_min)/2),').']);
T_avg_gray = T_avg_gray / r_length;
disp(['Kontrollsnitt: ',num2str(T_avg_gray),'. (Skal vre ',num2str((r_max+r_min)/2),').']);
disp(' ')

%% Gjennomsnittstemperatur 2D-bilde
T_avg = 0;
teller = 0;
maxTemp = 0;
minTemp = 1000;
for i = 1:im_height
    for j = 1:im_width
        fargeindeks = find(conmat(:,1)==Image_I(i,j)); %Kobler farge med temperatur
        temp = conmat(fargeindeks,2);
        %Hvis fargens temperatur tilsvarer temp_min eller lavere, eller
        %temp_max eller hyere, sett farge lik farge nummer 0 (nesten svart)
        if (temp <= temp_min)
            Image_I(i,j) = 0;
        elseif (temp >= temp_max)
            Image_I(i,j) = 0;
        else    %Beregner kun de feltene p bildet med temperaturer mellom temp_min og temp_max
            T_avg = T_avg + temp;
            teller = teller + 1;
            if temp > maxTemp      %Finner maks.temp. og posisjon
                maxTemp = temp;
                maxTpos = [i,j];
            end
            if temp < minTemp       %Finner min.temp. og posisjon
                minTemp = temp;
                minTpos = [i,j];
            end
        end
    end
end
T_avg = T_avg/teller;   %Gjennomsnittstemperatur

%% Metode 2 'nodither'
T_avg2 = 0;
teller2 = 0;
maxTemp2 = 0;
minTemp2 = 1000;
for i = 1:im_height
    for j = 1:im_width
        fargeindeks2 = find(conmat2(:,1)==Image_I2(i,j)); %Kobler farge med temperatur
        temp2 = conmat2(fargeindeks2,2);
        %Hvis fargens temperatur tilsvarer temp_min eller lavere, eller
        %temp_max eller hyere, sett farge lik farge nummer 0 (nesten svart)
        if (temp2 <= temp_min)
            Image_I2(i,j) = 0;
        elseif (temp2 >= temp_max)
            Image_I2(i,j) = 0;
        else    %Beregner kun de feltene p bildet med temperaturer mellom temp_min og temp_max
            T_avg2 = T_avg2 + temp2;
            teller2 = teller2 + 1;
            if temp2 > maxTemp2      %Finner maks.temp. og posisjon
                maxTemp2 = temp2;
                maxTpos2 = [i,j];
            end
            if temp2 < minTemp2       %Finner min.temp. og posisjon
                minTemp2 = temp2;
                minTpos2 = [i,j];
            end
        end
    end
end
Image_I2(maxTpos(1),maxTpos(2)) = 200;
Image_I2(minTpos(1),minTpos(2)) = 100;
T_avg2 = T_avg2/teller2;   %Gjennomsnittstemperatur

%% Metode gr
T_avg3 = 0;
teller3 = 0;
maxTemp3 = 0;
minTemp3 = 1000;
for i = 1:im_height
    for j = 1:im_width
        fargeindeks3 = find(conmat_gray(:,1)==Image_gray(i,j)); %Kobler farge med temperatur
        if size(fargeindeks3,1) == 0
            fargeindeks3 = finn_fargeindeks(conmat_gray,Image_gray(i,j));
        end
        temp3 = conmat_gray(fargeindeks3,2);
        %Hvis fargens temperatur tilsvarer temp_min eller lavere, eller
        %temp_max eller hyere, sett farge lik farge nummer 0 (nesten svart)
        if (temp3 <= temp_min)
            Image_gray(i,j) = 0;
        elseif (temp3 >= temp_max)
            Image_gray(i,j) = 0;
        else    %Beregner kun de feltene p bildet med temperaturer mellom temp_min og temp_max
            T_avg3 = T_avg3 + temp3;
            teller3 = teller3 + 1;
            if temp3 > maxTemp3      %Finner maks.temp. og posisjon
                maxTemp3 = temp3;
                maxTpos3 = [i,j];
            end
            if temp3 < minTemp3       %Finner min.temp. og posisjon
                minTemp3 = temp3;
                minTpos3 = [i,j];
            end
        end
    end
end
T_avg3 = T_avg3/teller3;   %Gjennomsnittstemperatur


%% Resultater
figure(1); imshow(Image_I_original,map);
figure(2); imshow(Image_I,map);
figure(3); imshow(Image_I2,map2);
figure(4); imshow(Image_gray);

disp(['Snittstemperatur for bilde nummer ',num2str(bildenummer),' er ',num2str(T_avg),' grader celsius. Areal = ',num2str(teller),' piksler.'])
disp(['Minimumstemperatur er ',num2str(minTemp),' grader.'])
disp(['Makstemperatur er ',num2str(maxTemp),' grader.'])
disp(' ')
disp(['Snittstemperatur for bilde nummer ',num2str(bildenummer),' er ',num2str(T_avg2),' grader celsius. Areal = ',num2str(teller2),' piksler.'])
disp(['Minimumstemperatur er ',num2str(minTemp2),' grader.'])
disp(['Makstemperatur er ',num2str(maxTemp2),' grader.'])
disp(' ')
disp(['Snittstemperatur for bilde nummer ',num2str(bildenummer),' er ',num2str(T_avg3),' grader celsius. Areal = ',num2str(teller3),' piksler.'])
disp(['Minimumstemperatur er ',num2str(minTemp3),' grader.'])
disp(['Makstemperatur er ',num2str(maxTemp3),' grader.'])
disp(' ')